<?php
/**
 *
 * 版权所有：安德玛(underArmour)
 * 作    者：1554324405@qq.com
 * 日    期：2020-05-20
 * 版    本：1.0.0
 * 功能说明：轮播图控制器。
 *
 **/

namespace Admin\Controller;

class BannerController extends ComController
{
    /**
     * 列表
     */
    public function index()
    {
        $model = M('banner');
        $list = $model->order('o asc')->select();
        $this->assign('list',$list);
        $this->display();
    }
    
    
    /**
     * 新增banner
     */
    public function add()
    {
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['pic'] = I('post.pic','','htmlspecialchars');
            $data['url'] = I('post.url','','htmlspecialchars');
            $data['o'] = I('post.o',99,'htmlspecialchars');
            if(!$data['title'] or !$data['pic']){
                $this->error('标题或图片存在空项，请检查表单项！');
            }
            $data['t'] = time();
            $res = M('banner')->data($data)->add();
            if($res){
                addlog('新增轮播图，ID：'.$res);
                $this->success('轮播图上传成功',U('index'));
            }else{
                $this->error('上传失败，请稍后再试！');
            }
        }else{
            $this->assign('method',U('Banner/add'));
            $this->display('form');
        }
    }
    
    
    /**
     * 修改banner
     */
    public function update()
    {
        $id = I('id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['pic'] = I('post.pic','','htmlspecialchars');
            $data['o'] = I('post.o',99,'htmlspecialchars');
            $data['url'] = I('post.url','','htmlspecialchars');
            if(!$data['title'] or !$data['pic']){
                $this->error('标题或图片存在空项，请检查表单项！');
            }
            $data['update_t'] = time();
            $res = M('banner')->where('id='.$id)->data($data)->save();
            if($res){
                addlog('修改轮播图，ID：'.$id);
                $this->success('轮播图修改成功',U('index'));
            }else{
                $this->error('上传失败，请稍后再试！');
            }
        }else{
            $vo = M('banner')->where('id='.$id)->find();
            $this->assign('method',U('Banner/update'));
            $this->assign('vo',$vo);
            $this->display('form');
        }
    }
    
    /**
     * 删除banner
     */
    public function delete()
    {
        $id = I('get.id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        $res = M('banner')->where('id='.$id)->delete();
        if($res){
            addlog('删除轮播图，ID：'.$id);
            $this->success('轮播图删除成功',U('index'));
        }else{
            $this->error('删除失败，请稍后再试！');
        }
    }
}