<?php
/**
 *
 * 版权所有：安德玛(underArmour)
 * 作    者：1554324405@qq.com
 * 日    期：2020-05-20
 * 版    本：1.0.0
 * 功能说明：轮播图控制器。
 *
 **/
namespace Admin\Controller;

class CategoryController extends ComController
{
    /**
     * 首页
     */
    public function index()
    {
        $model = M('category');
        $list = $model->order('o asc')->select();
        $this->assign('list',$list);
        $this->display();
    }
    
    
    /**
     * 新增
     */
    public function add()
    {
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['icon'] = I('post.icon','','htmlspecialchars');
            $data['o'] = I('post.o',99,'htmlspecialchars');
            if(!$data['title'] or !$data['icon']){
                $this->error('标题或图标存在空项，请检查表单项！');
            }
            $data['t'] = time();
            $res = M('category')->data($data)->add();
            if($res){
                addlog('新增任务分类，ID：'.$res);
                $this->success('操作成功',U('index'));
            }else{
                $this->error('操作失败，请稍后再试！');
            }
        }else{
            $this->assign('method',U('Category/add'));
            $this->display('form');
        }
    }
    
    
    /**
     * 修改
     */
    public function update()
    {
        $id = I('id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['icon'] = I('post.icon','','htmlspecialchars');
            $data['o'] = I('post.o',99,'htmlspecialchars');
            if(!$data['title'] or !$data['icon']){
                $this->error('标题或图片存在空项，请检查表单项！');
            }
            $data['update_t'] = time();
            $res = M('category')->where('id='.$id)->data($data)->save();
            if($res){
                addlog('修改任务分类，ID：'.$id);
                $this->success('操作成功',U('index'));
            }else{
                $this->error('操作失败，请稍后再试！');
            }
        }else{
            $vo = M('category')->where('id='.$id)->find();
            $this->assign('method',U('Category/update'));
            $this->assign('vo',$vo);
            $this->display('form');
        }
    }
    
    /**
     * 删除
     */
    public function delete()
    {
        $id = I('get.id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        $res = M('category')->where('id='.$id)->delete();
        if($res){
            addlog('删除任务分类，ID：'.$id);
            $this->success('删除成功',U('index'));
        }else{
            $this->error('删除失败，请稍后再试！');
        }
    }
    
}