<?php
/**
 *
 * 版权所有：安德玛(underArmour)
 * 作    者：1554324405@qq.com
 * 日    期：2020-05-20
 * 版    本：1.0.0
 * 功能说明：用户等级控制器。
 *
 **/
namespace Admin\Controller;

class LevelController extends ComController
{
    /**
     * 首页
     */
    public function index()
    {
        $model = M('user_level');
        $list = $model->order('o asc')->select();
        $this->assign('list',$list);
        $this->display();
    }
    
    
    /**
     * 新增
     */
    public function add()
    {
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['icon'] = I('post.icon','','htmlspecialchars');
            $data['card_pic'] = I('post.card_pic','','htmlspecialchars');
            $data['o'] = I('post.o',9,'htmlspecialchars');
            $data['price'] = I('post.price',0,'htmlspecialchars');
            $data['day_num'] = I('post.day_num','','htmlspecialchars');
            $data['expri_day'] = I('post.expri_day',10,'htmlspecialchars');
            $data['fenyong_1'] = I('post.fenyong_1',0,'htmlspecialchars');
            $data['fenyong_2'] = I('post.fenyong_2',0,'htmlspecialchars');
            $data['jiangli_1'] = I('post.jiangli_1',0,'htmlspecialchars');
            $data['jiangli_2'] = I('post.jiangli_2',0,'htmlspecialchars');
            $data['is_red'] = I('post.is_red',0,'htmlspecialchars');
            $data['is_r'] = I('post.is_r',0,'htmlspecialchars');
            $data['bg_color'] = I('post.bg_color','','htmlspecialchars');
            
            if(!$data['title'] or !$data['icon'] or !$data['o'] or !$data['day_num'] 
                or !$data['expri_day'] or !$data['card_pic']){
                $this->error('必填字段存在空项，请检查表单项！');
            }
            $data['t'] = time();
            $res = M('user_level')->data($data)->add();
            if($res){
                addlog('新增会员等级，ID：'.$res);
                $this->success('操作成功',U('index'));
            }else{
                $this->error('操作失败，请稍后再试！');
            }
        }else{
            $this->assign('method',U('Level/add'));
            $this->display('form');
        }
    }
    
    
    /**
     * 修改
     */
    public function update()
    {
        $id = I('id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        if(IS_POST){
            $data['title'] = I('post.title','','htmlspecialchars');
            $data['icon'] = I('post.icon','','htmlspecialchars');
            $data['card_pic'] = I('post.card_pic','','htmlspecialchars');
            $data['o'] = I('post.o',9,'htmlspecialchars');
            $data['price'] = I('post.price',0,'htmlspecialchars');
            $data['day_num'] = I('post.day_num','','htmlspecialchars');
            $data['expri_day'] = I('post.expri_day',10,'htmlspecialchars');
            $data['fenyong_1'] = I('post.fenyong_1',0,'htmlspecialchars');
            $data['fenyong_2'] = I('post.fenyong_2',0,'htmlspecialchars');
            $data['jiangli_1'] = I('post.jiangli_1',0,'htmlspecialchars');
            $data['jiangli_2'] = I('post.jiangli_2',0,'htmlspecialchars');
            $data['is_red'] = I('post.is_red',0,'htmlspecialchars');
            $data['is_r'] = I('post.is_r',0,'htmlspecialchars');
            $data['bg_color'] = I('post.bg_color','','htmlspecialchars');
            
            if(!$data['title'] or !$data['icon'] or !$data['o'] or !$data['day_num']
                or !$data['expri_day'] or !$data['card_pic']){
                    $this->error('必填字段存在空项，请检查表单项！');
            }
            $data['update_t'] = time();
            $res = M('user_level')->where('id='.$id)->data($data)->save();
            if($res){
                addlog('修改会员等级，ID：'.$id);
                $this->success('操作成功',U('index'));
            }else{
                $this->error('操作失败，请稍后再试！');
            }
        }else{
            $vo = M('user_level')->where('id='.$id)->find();
            $this->assign('method',U('Level/update'));
            $this->assign('vo',$vo);
            $this->display('form');
        }
    }
    
    /**
     * 删除
     */
    public function delete()
    {
        $id = I('get.id');
        if(!$id){
            $this->error('传参不合法，请检查链接是否正确！');
        }
        $res = M('user_level')->where('id='.$id)->delete();
        if($res){
            addlog('删除会员等级，ID：'.$id);
            $this->success('删除成功',U('index'));
        }else{
            $this->error('删除失败，请稍后再试！');
        }
    }
    
}